Loading...
Searching...
No Matches
Qore::HashPairIterator Class Reference

This class an iterator class for hashes. More...

`#include <QC_HashPairIterator.dox.h>`

Inheritance diagram for Qore::HashPairIterator:
[legend]

## Public Member Functions

| constructor (hash< auto > h)
| Creates the hash iterator object.
| constructor ()
| Creates an empty hash iterator object.
| copy ()
| Creates a copy of the HashPairIterator object, iterating the same object as the original and in the same position.
hash< auto > | getValue ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid
Public Member Functions inherited from Qore::HashIterator
| constructor (hash< auto > h)
| Creates the hash iterator object.
| constructor ()
| Creates an empty hash iterator object.
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position.
bool | empty ()
| returns True if the hash is empty; False if not
bool | first ()
| returns True if on the first element of the hash
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid
auto | getKeyValue ()
| returns the current value of the current hash key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid
auto | getValue ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid
hash< auto > | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid
bool | last ()
| returns True if on the last element of the hash
bool | next ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty.
bool | prev ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty.
| reset ()
| Reset the iterator instance to its initial state.
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not
Public Member Functions inherited from Qore::AbstractBidirectionalIterator
abstract bool | prev ()
| Moves the current position to the previous element; returns False if there are no more elements.
Public Member Functions inherited from Qore::AbstractIterator
abstract auto | getValue ()
| returns the current value
abstract bool | next ()
| Moves the current position to the next element; returns False if there are no more elements.
abstract bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not
Public Member Functions inherited from Qore::AbstractQuantifiedIterator
abstract bool | empty ()
| returns True if the object to iterate is empty; False if not
abstract bool | first ()
| returns True if on the first element
abstract bool | last ()
| returns True if on the last element

## Detailed Description

This class an iterator class for hashes.

Call HashPairIterator::next() to iterate through the hash; do not use the iterator if HashPairIterator::next() returns False. A hash can be iterated in reverse order by calling HashPairIterator::prev() instead of HashPairIterator::next()

Example: HashPairIterator basic usage
  hash<auto> data = {
  "key1" : 1,
  "key2" : 2,
  "key3" : 3,
  };
  HashPairIterator it(data);
  while (it.next()) {
  printf("iter: %n\n", it.getValue());
  }
  iter: hash: (key : "key1", value : 1)
  iter: hash: (key : "key2", value : 2)
  iter: hash: (key : "key3", value : 3)

Note
  - In general, the HashPairIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.

See also
  HashPairReverseIterator

## Member Function Documentation

## constructor() [1/2]

Qore::HashPairIterator::constructor | ( |  | ) |

Creates an empty hash iterator object.

Example:
  *hash<auto> h = get_hash_or_nothing();
  HashPairIterator hi(h);

## constructor() [2/2]

Qore::HashPairIterator::constructor | ( | hash< auto > | h | ) |

Creates the hash iterator object.

Parameters

  h | the hash to iterate

Example:
  HashPairIterator hi(h);

## copy()

Qore::HashPairIterator::copy | ( |  | ) |

Creates a copy of the HashPairIterator object, iterating the same object as the original and in the same position.

Example:
  HashPairIterator ni = i.copy();

## getValue()

hash< auto > Qore::HashPairIterator::getValue | ( |  | ) |

returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Returns
  a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  map printf("%s: %y\n", $1.key, $1.value), hash.pairIterator();

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Since
  Qore 0.8.6.2